﻿function refreshFriendsList() {

   friends = googleTalk.friends.toArray(); 

   //check if Google Talk is running
   if (googleTalk.talk_status==gddTalkStatusNotRunning) {
     var item = new ContentItem();
     item.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
     item.layout = gddContentItemLayoutNowrapItems;
     item.heading = "- Google Talk is not Running -";
     item.onDetailsView = noAction;

     cnArea.removeAllContentItems();
     cnArea.addContentItem(item, gddItemDisplayInSidebar);
     return;
   }

   //check if Google Talk is running
   if (googleTalk.talk_status==gddTalkStatusDisconnected) {
     var item = new ContentItem();
     item.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
     item.layout = gddContentItemLayoutNowrapItems;
     item.heading = "- Google Talk is not connected -";
     item.onDetailsView = noAction;

     cnArea.removeAllContentItems();
     cnArea.addContentItem(item, gddItemDisplayInSidebar);
     return;
   }

   //check no friends
   if (friends.length==0 || friends==null) {
     var item = new ContentItem();
     item.flags = gddContentItemFlagNoRemove + gddContentItemFlagStatic;
     item.layout = gddContentItemLayoutNowrapItems;
     item.heading = "- No Friends Online -";
     item.onDetailsView = noAction;

     cnArea.removeAllContentItems();
     cnArea.addContentItem(item, gddItemDisplayInSidebar);
     return;
   }

   //if(prv_num_friends != friends.length) {
      cnArea.removeAllContentItems();
      for(var t=friends.length-1; t>=0; t--) {

        var itemImg;
        var item = new ContentItem();
        item.flags = gddContentItemFlagNoRemove + gddContentItemFlagLeftIcon;
        item.layout = gddContentItemLayoutEmail;
        item.heading = friends[t].name;
        item.snippet = (friends[t].status==gddFriendStatusOnline?"Online":(friends[t].status==gddFriendStatusBusy?"Busy":"Idle"));
        item.source = friends[t].user_id;
        item.open_command = (friends[t].has_sidebar?"Has Sidebar":"No Sidebar");
        item.tooltip = item.open_command;
        itemImg = (friends[t].has_sidebar?"gd_enb.PNG":"gd_dis.PNG");
        item.onDetailsView = selectFriend;
        item.onDrawItem = DrawItem;

        cnArea.addContentItem(item, gddItemDisplayInSidebar);
      }
   //}

   //prv_num_friends = friends.length;
}

function DrawItem(item, target, graphics, x, y, width, height) {

  var bgColor2 = (item.open_command=="Has Sidebar"?"#B27EC6":"#B0B0AF");
  graphics.DrawRect(x, y+4, x+5, height/3, bgColor2, bgColor2);

  var bgColor1 = (item.snippet=="Online"?"#64B864":(item.snippet=="Busy"?"#FF5655":"#EA8F5D"));
  graphics.DrawRect(x, y+20, x+5, height/3, bgColor1, bgColor1);

  graphics.DrawText(x+6, y+3, width, height, "   " + item.heading + " | " + item.open_command, gddColorNormalText, gddTextFlagVCenter, gddFontNormal); //gddColorNormalText gddTextFlagSingleLine +
  graphics.DrawText(x+6, y+20, width, height, "   " + item.snippet, bgColor1, gddTextFlagVCenter, gddFontNormal);
}

function selectFriend(item) {

   var frndStat = item.snippet;

   if(selectFriendAction=="send") {
     selectedFrndLbl.innerText = item.heading;
     FrndStatus.src = "FrndStatus/" + frndStat + ".png";
     selectFriendSendHasSB = (item.open_command=="Has Sidebar"?"true":"false");
     FrndHasSB.src = "FrndStatus/" + (selectFriendSendHasSB=="true"?"gd_enb":"gd_dis") + ".png";
     SendOptions.name = item.heading;
     SendOptions.uid = item.source;
   }
   if(selectFriendAction=="guess") {
     guessedFriendlbl.innerText = item.heading;
     GuessOptions.name = item.heading;
     GuessOptions.uid = item.source;
     verifyGuessedFriend();
   }
   
   showHideFriendList();

}

function showHideFriendList() {

   if(cnAreaDis){ resetCnA(); buttGuessTk = setInterval("animateButtGuess()", 500); /*clearInterval(friendstimer);*/ }
   else{ setCnA(); clearInterval(buttGuessTk); /*friendstimer = setInterval("refreshFriendsList()",500);*/ }

   refreshFriendsList();
}

function verifyGuessedFriend() {

   if(GuessOptions.uid == RealSenderUid) {
     alert("You guessed it correctly... "); setGuessed(GuessingCrushId);
     googleTalk.sendTalkDataEx(RealSenderUid, "guessedIt", gddSendDataFlagSilent);
     setCrushView(guessedFriendlbl.innerText,crushMsg.innerText);
   }
   else alert("Ooops! Try again. :)");
}