﻿var URL, loadedFile;
var ParentNodeName = "data", childNodeName = "crush";
var DataNodes, XMLDoc;
var subChildNodeName1 = "id", subChildNodeName2 = "name", subChildNodeName3 = "msg", subChildNodeName4 = "type", subChildNodeName5 = "date", subChildNodeName6 = "guessed", subChildNodeName7 = "uid";;

function getPath() {

//retrieving User folder
  userPath=new String();
  var path=new ActiveXObject("WScript.Shell");
  userPath=path.SpecialFolders("MyDocuments");
  path=null;

  for (var p=userPath.length; userPath.charAt(p)!="\\"; p--)
  {}
  userPath=userPath.substring(0,p);
  userPath=userPath+"\\Crush";

  URL = userPath;
  crateFiles();
}

function crateFiles(){

 var fso = system.filesystem;
 if(!fso.FolderExists(URL)){ fso.createFolder(URL);}

 if(!fso.FileExists(URL + "\\indata.xml")){
   var s = fso.CreateTextFile(URL + "\\indata.xml", true);
   s.WriteLine("<data></data>");
   s.Close();
 }

 if(!fso.FileExists(URL + "\\outdata.xml")){
   var s = fso.CreateTextFile(URL + "\\outdata.xml", true);
   s.WriteLine("<data></data>");
   s.Close();
 }
}

function loadData(fname) {

  XMLDoc = new ActiveXObject("MSXML2.DOMDocument.3.0");
  XMLDoc.async = false;
  XMLDoc.load(URL +"\\"+ fname);
  loadedFile = URL +"\\"+ fname;
  if (XMLDoc.parseError.errorCode != 0) {
    alert("Error: Data XML is Not Loaded : "); return;
  }

  cnArea.removeAllContentItems();
  DataNodes = XMLDoc.selectNodes("/"+ParentNodeName+"/"+childNodeName);
  for(var i=0; i<DataNodes.length; i++) { addItem(i); }
  showHideMsgList();
}

function changeFile(fname) {

  getPath();
  XMLDoc = new ActiveXObject("MSXML2.DOMDocument.3.0");
  XMLDoc.async = false;
  XMLDoc.load(URL +"\\"+ fname);
  loadedFile = URL +"\\"+ fname;
  if (XMLDoc.parseError.errorCode != 0) {
    alert("Error: Data XML is Not Loaded : "); return;
  }
}

function addItem(ix) {

   var item = new ContentItem();

   var CrushNodes = DataNodes(ix).childNodes;
   item.flags = gddContentItemFlagLeftIcon;
   item.layout = gddContentItemLayoutNews;
   item.heading = (CrushNodes(5).text=="0"?CrushNodes(4).text:CrushNodes(1).text);
   item.source = ix;
   item.onDetailsView = onSelect;
   item.tooltip = "Message "+ix;
   item.image = (CrushNodes(5).text=="1"?graphics.loadImage("InOutBox/sign_g.png"):graphics.loadImage("InOutBox/sign.png"));
   item.onRemoveItem = onRemove;

   cnArea.addContentItem(item, gddItemDisplayInSidebar);
}

function onSelect(item) {
   var ctype, sender, mmsg;
   var i = item.source;

   sender = DataNodes(i).childNodes(1).text;
   mmsg = DataNodes(i).childNodes(2).text;
   ctype = DataNodes(i).childNodes(3).text;
   RealSenderUid = DataNodes(i).childNodes(6).text;
   GuessingCrushId = DataNodes(i).childNodes(0).text;;

   (DataNodes(i).childNodes(5).text=="0"?setCrushViewGuess(sender,mmsg):setCrushView(sender,mmsg));
   openCrush(ctype);
}

function onRemove(item) {
   if(confirm("Are you sure you want to remove this message ?")==true) {
      removeElement(item.source);
   }

   if(currView == "IN") {
      CinClick();
   }
   else if(currView == "OUT") {
      CoutClick();
   }
   else if(currView == "SEND") {
      CrushClick();
   }
}

function showHideMsgList() {

   if(cnAreaDis){ resetCnA(); }
   else{ setCnA(); cnArea.height = 150;}
}

function addElement(subChildNodeName1Val, subChildNodeName2Val, subChildNodeName3Val, subChildNodeName4Val, subChildNodeName5Val, subChildNodeName6Val, subChildNodeName7Val) {

  var ParenNode = XMLDoc.selectNodes("/"+ParentNodeName);
  var aElement = XMLDoc.createElement(childNodeName);
  ParenNode(0).appendChild(aElement);

  var subElement1 = XMLDoc.createElement(subChildNodeName1);
  subElement1.nodeTypedValue = subChildNodeName1Val;
  aElement.appendChild(subElement1);

  var subElement2 = XMLDoc.createElement(subChildNodeName2);
  subElement2.nodeTypedValue = subChildNodeName2Val;
  aElement.appendChild(subElement2);

  var subElement3 = XMLDoc.createElement(subChildNodeName3);
  subElement3.nodeTypedValue = subChildNodeName3Val;
  aElement.appendChild(subElement3);

  var subElement4 = XMLDoc.createElement(subChildNodeName4);
  subElement4.nodeTypedValue = subChildNodeName4Val;
  aElement.appendChild(subElement4);

  var subElement5 = XMLDoc.createElement(subChildNodeName5);
  subElement5.nodeTypedValue = subChildNodeName5Val;
  aElement.appendChild(subElement5);

  var subElement6 = XMLDoc.createElement(subChildNodeName6);
  subElement6.nodeTypedValue = subChildNodeName6Val;
  aElement.appendChild(subElement6);

  var subElement7 = XMLDoc.createElement(subChildNodeName7);
  subElement7.nodeTypedValue = subChildNodeName7Val;
  aElement.appendChild(subElement7);

  XMLDoc.save(loadedFile);
}

function removeElement(elementNum) {

  var ParenNode = XMLDoc.selectNodes("/"+ParentNodeName);
  var qString = DataNodes(elementNum).childNodes(0).text;
  var OldNode = XMLDoc.selectSingleNode("/"+ParentNodeName+"/"+childNodeName+"["+subChildNodeName1+"='"+qString+"']");
  ParenNode(0).removeChild(OldNode);

  XMLDoc.save(loadedFile);
  setInbox();
  setOutbox();
}

function setGuessed(elementNum) {

  var newNode = XMLDoc.createElement(subChildNodeName6);
  newNode.nodeTypedValue = "1";

  var ParenNode = XMLDoc.selectSingleNode("/"+ParentNodeName+"/"+childNodeName+"["+subChildNodeName1+"='"+elementNum+"']");
  var OldNode = XMLDoc.selectSingleNode("/"+ParentNodeName+"/"+childNodeName+"["+subChildNodeName1+"='"+elementNum+"']/guessed");;

  ParenNode.replaceChild(newNode,OldNode);

  XMLDoc.save(loadedFile);
  setInbox();
  setOutbox();
}